<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import type { User } from '@/types/User'
import { nextTick, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const props = defineProps<{
  user: User
}>()
const emit = defineEmits<{
  selectedUser: [User]
}>()

emit('selectedUser', props.user)

const authStore = useAuthStore()

let editedIndex = -1
const editedUser = ref<User>(JSON.parse(JSON.stringify(authStore.currentUser)))
const users = ref<User[]>([])
users.value = authStore.users
const dialog = ref(false)
const form = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)
let lastestId = 1
let latestId = 1
users.value.forEach((user) => {
  if (user.id > lastestId) {
    latestId = user.id
  }
})
lastestId = latestId + 1

function editItem(item: User) {
  editedIndex = users.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialog.value = true
}

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, authStore.currentUser)
    editedIndex = -1
  })
}
function openEditDialog() {
  editItem(props.user)
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(users.value[editedIndex], editedUser.value)
  } else {
    editedUser.value.id = lastestId++
    users.value.push(editedUser.value)
  }
  closeDialog()
}
function deleteItem(item: User) {
  editedIndex = users.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialogDelete.value = true
}

function deleteItemConfirm() {
  users.value.splice(editedIndex, 1)
  closeDelete()
}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, authStore.currentUser)
  })
  editedIndex = -1
}

const roles = ['admin', 'user']

function upper1st(str: string | undefined) {
  if (!str) {
    return ''
  }
  return str.charAt(0).toUpperCase() + str.slice(1)
}
</script>
<template>
  <v-table :items="users">
    <v-card class="mx-4 my-12" max-width="600" color="white">
      <v-img cover height="280" src="./img/otherImage/Adminpic.jpg"></v-img>
      <v-card-item>
        <v-card-title style="font-size: 25px">{{ user.fullname }}</v-card-title>
      </v-card-item>
      <v-card-text>
        <v-divider class="mx-4 mb-1"></v-divider>
        <div class="my-4 text-subtitle-1">ID: {{ user.id }}</div>
        <div class="my-4 text-subtitle-1">Email: {{ user.email }}</div>
        <div class="my-4 text-subtitle-1">Gender: {{ upper1st(user.gender) }}</div>
        <div class="my-4 text-subtitle-1">
          Role: {{ user.roles.map((role) => upper1st(role)).join(', ') }}
        </div>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-icon size="small" class="me-2" v-model="dialog" @click="editItem(user)"
            >mdi-pencil</v-icon
          >
          <v-icon size="small" v-model="dialogDelete" @click="deleteItem(user)">
            mdi-delete
          </v-icon>
        </v-card-actions>
      </v-card-text>
      <v-dialog v-model="dialogDelete" width="500px">
        <v-card>
          <br />
          <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
          <v-spacer></v-spacer>
          <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
          <v-card-title align="center" class="text-h10">
            This action cannot be undone.<br />
            All values associated with this field will be lost.
          </v-card-title>
          <v-spacer></v-spacer>
          <div align="center">
            <div style="margin: 0 auto; max-width: 400px">
              <v-btn
                block
                style="background-color: #e11d48"
                color="white"
                variant="text"
                @click="deleteItemConfirm()"
              >
                Delete field
              </v-btn>
            </div>
          </div>
          <div align="center">
            <div
              style="
                margin: 0 auto;
                max-width: 400px;
                border: 1px solid #dfe1e6;
                border-radius: 5px;
                margin-top: 10px;
              "
            >
              <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
            </div>
          </div>
          <v-spacer></v-spacer>
          <br />
        </v-card>
      </v-dialog>
    </v-card>
  </v-table>

  <v-dialog v-model="dialog" persistent width="1024">
    <v-card>
      <v-card-title>
        <span class="text-h5">User</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="6">
                <v-text-field
                  v-model="editedUser.email"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  class="mb-2"
                  clearable
                  label="Email"
                ></v-text-field>
              </v-col>

              <v-col cols="12" sm="12" md="6">
                <v-text-field
                  v-model="editedUser.fullname"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  class="mb-2"
                  clearable
                  label="Full Name"
                ></v-text-field>
              </v-col>

              <v-col cols="12" sm="5" md="6">
                <v-text-field
                  v-model="editedUser.username"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  class="mb-2"
                  clearable
                  label="Username"
                ></v-text-field>
              </v-col>

              <v-col cols="12" sm="5" md="6">
                <v-text-field
                  v-model="editedUser.password"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  class="mb-2"
                  clearable
                  label="Password"
                ></v-text-field>
              </v-col>

              <v-col cols="12" sm="12" md="2">
                <v-combobox
                  v-model="editedUser.gender"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  :items="[
                    { title: 'Male', value: 'male' },
                    { title: 'Female', value: 'female' },
                    { title: 'Others', value: 'others' }
                  ]"
                  label="Gender"
                  :return-object="false"
                ></v-combobox>
              </v-col>

              <v-col cols="12" sm="12" md="3">
                <v-combobox
                  v-model="editedUser.roles"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  :items="roles"
                  label="Roles"
                  multiple
                  chips
                ></v-combobox>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small style="color: red">*Please fill data</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
        <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
